Loading...
Searching...
No Matches
BALL::Product< First, Second, DataType > Class Template Reference

`#include <BALL/MATHS/function.h>`

## Public Member Functions

Constructors and destructor
| Product ()
| Product (const Product &product)
virtual | ~Product ()
Assignment
Product< First, Second, DataType > & | operator= (const Product< First, Second, DataType > &product)
Predicates
bool | operator== (const Product< First, Second, DataType > &product) const
Function realization
BALL_INLINE DataType | operator() (const DataType &x) const

## Accessors

First | first_
Second | second_
void | setFirst (const First &first)
First & | getFirst ()
const First & | getFirst () const
void | setSecond (const Second &second)
Second & | getSecond ()

## Detailed Description

template<typename First, typename Second, typename DataType = float>
class BALL::Product< First, Second, DataType >

Multiplication class.

Definition at line 372 of file function.h.

## Constructor & Destructor Documentation

## Product() [1/2]

template<typename First, typename Second, typename DataType>

BALL_INLINE BALL::Product< First, Second, DataType >::Product | ( |  | ) |

Default constructor

Definition at line 1109 of file function.h.

## Product() [2/2]

template<typename First, typename Second, typename DataType>

BALL_INLINE BALL::Product< First, Second, DataType >::Product | ( | const Product< First, Second, DataType > & | product | ) |

Copy constructor

Definition at line 1117 of file function.h.

## ~Product()

template<typename First, typename Second, typename DataType>

BALL_INLINE BALL::Product< First, Second, DataType >::~Product | ( |  | ) |

virtual

Destructor

Definition at line 1125 of file function.h.

## Member Function Documentation

## getFirst() [1/2]

template<typename First, typename Second, typename DataType = float>

First & BALL::Product< First, Second, DataType >::getFirst | ( |  | ) |

inline

get the first argument of the product

Returns
  a const reference to the first argument

Definition at line 442 of file function.h.

## getFirst() [2/2]

template<typename First, typename Second, typename DataType = float>

const First & BALL::Product< First, Second, DataType >::getFirst | ( |  | ) | const

inline

Get the first argument of the product (const version).

Returns
  a const reference to the first argument

Definition at line 450 of file function.h.

## getSecond()

template<typename First, typename Second, typename DataType = float>

Second & BALL::Product< First, Second, DataType >::getSecond | ( |  | ) |

inline

get the second argument of the product

Returns
  a const reference to the second argument

Definition at line 466 of file function.h.

## operator()()

template<typename First, typename Second, typename DataType = float>

BALL_INLINE DataType BALL::Product< First, Second, DataType >::operator() | ( | const DataType & | x | ) | const

inline

Evaluation of this subterm

Parameters

  x | the point where to evaluate

Returns
  the function value

Definition at line 422 of file function.h.

## operator=()

template<typename First, typename Second, typename DataType>

BALL_INLINE Product< First, Second, DataType > & BALL::Product< First, Second, DataType >::operator= | ( | const Product< First, Second, DataType > & | product | ) |

Assignment operator

Definition at line 1131 of file function.h.

## operator==()

template<typename First, typename Second, typename DataType>

BALL_INLINE bool BALL::Product< First, Second, DataType >::operator== | ( | const Product< First, Second, DataType > & | product | ) | const

Equality operator

Definition at line 1140 of file function.h.

## setFirst()

template<typename First, typename Second, typename DataType = float>

void BALL::Product< First, Second, DataType >::setFirst | ( | const First & | first | ) |

inline

set the first argument of the product

Definition at line 434 of file function.h.

## setSecond()

template<typename First, typename Second, typename DataType = float>

void BALL::Product< First, Second, DataType >::setSecond | ( | const Second & | second | ) |

inline

set the second argument of the product

Parameters

  second | the second argument

Definition at line 458 of file function.h.

## Member Data Documentation

## first_

template<typename First, typename Second, typename DataType = float>

First BALL::Product< First, Second, DataType >::first_

protected

Definition at line 477 of file function.h.

## second_

template<typename First, typename Second, typename DataType = float>

Second BALL::Product< First, Second, DataType >::second_

protected

Definition at line 481 of file function.h.